<?php

class SipWizard 
{
	var $which_scenario = 1;

	// sip variables
	var $sip_name 	  = 'sip_name'	  ;
	var $sip_server   = 'sip_server'  ;
	var $sip_user 	  = 'sip_user'	  ;
	var $sip_secret	  = 'sip_secret'  ;
	var $sip_register = 'sip_register';

	var $sip_array_parameter = array('sip_name'	=> array( 'idurl' => 'SIP_name'	   , 'title' => SIP_NAME_DIS			, 'tooltip' => TRUNKS_SIP_NAME	   , 'input' => 'text'	  ), 
					 'sip_server'	=> array( 'idurl' => 'SIP_server'  , 'title' => WIZARD_SIP_SERVER_ADDRESS_DIS	, 'tooltip' => TRUNKS_SIP_REGISTRAR, 'input' => 'text'	  ),
					 'sip_user'	=> array( 'idurl' => 'SIP_user'	   , 'title' => SIP_USER_DIS			, 'tooltip' => TRUNKS_SIP_USER	   , 'input' => 'text'	  ),
					 'sip_secret'	=> array( 'idurl' => 'SIP_secret'  , 'title' => SIP_SECRET_DIS			, 'tooltip' => TRUNKS_SIP_SECRET   , 'input' => 'text'	  ),
					 'sip_register'	=> array( 'idurl' => 'SIP_register', 'title' => SIP_REGISTER_DIS		, 'tooltip' => TRUNKS_SIP_REGISTER , 'input' => 'checkbox'));

	// pbx variables 
	var $pbx_server = 'server_addr';
	var $pbx_port	= 'server_port';

	var $pbx_array_parameter = array('server_addr' => array( 'idurl' => 'PbxServer' , 'title' => ''	, 'tooltip' => ''	, 'input' => 'text'	),
					 'server_port' => array( 'idurl' => 'PbxPort' 	, 'title' => ''	, 'tooltip' => ''	, 'input' => 'text'	));
	
	var $ids_array = array();

	function __construct($init = true, $scenario = 1) // gateway = 1    -   pbx = 2   -   provider = 3    -    manual = 4
	{
		if ($init)
		{
			switch ($scenario)
			{
				default:
				case 1:
					$this -> ids_array = array( 	$this -> sip_array_parameter[$this -> sip_name]['idurl'] 	=> array( 'id'   => $this -> sip_name   	, 'object' => '.value'		   ),	
									$this -> sip_array_parameter[$this -> sip_server]['idurl'] 	=> array( 'id'   => $this -> sip_server   	, 'object' => '.value'		   ),
									$this -> sip_array_parameter[$this -> sip_user]['idurl'] 	=> array( 'id'   => $this -> sip_user     	, 'object' => '.value'		   ),
									$this -> sip_array_parameter[$this -> sip_secret]['idurl'] 	=> array( 'id'   => $this -> sip_secret   	, 'object' => '.value'		   ),
									$this -> sip_array_parameter[$this -> sip_register]['idurl']	=> array( 'id'   => $this -> sip_register 	, 'object' => '.checked.toString()'));
					break;
				case 2:
					$this -> which_scenario = 2;
					$this -> ids_array = array(	$this -> pbx_array_parameter[$this -> pbx_server]['idurl']	=> array( 'id'	=> $this -> pbx_server	, 'object' => '.value'	),
									$this -> pbx_array_parameter[$this -> pbx_port]['idurl']	=> array( 'id'	=> $this -> pbx_port	, 'object' => '.value'	));
					break;
				case 3:
					$this -> which_scenario = 3;
					break;
				case 4:
					$this -> which_scenario = 4;
					$this -> ids_array = array(	$this -> sip_array_parameter[$this -> sip_name]['idurl'] 	=> array( 'id'   => $this -> sip_name   	, 'object' => '.value'		   ),	
									$this -> sip_array_parameter[$this -> sip_server]['idurl'] 	=> array( 'id'   => $this -> sip_server   	, 'object' => '.value'		   ),
									$this -> sip_array_parameter[$this -> sip_user]['idurl'] 	=> array( 'id'   => $this -> sip_user     	, 'object' => '.value'		   ),
									$this -> sip_array_parameter[$this -> sip_secret]['idurl'] 	=> array( 'id'   => $this -> sip_secret   	, 'object' => '.value'		   ),
									$this -> sip_array_parameter[$this -> sip_register]['idurl']	=> array( 'id'   => $this -> sip_register 	, 'object' => '.checked.toString()'));
					break;
			}
		}
	}

	// private
	function _display_simple_field ($div_id, $label, $input_id, $title, $value = '', $type = 'text', $javascript = '', $tab = '', $autocomplete = '')
	{
		$checked = '';
		$class 	 = "class='form-control input-sm'";
		if (strcmp($type, 'checkbox') == 0)
		{
			$class   = "class=''";
			$checked = (($value) ? ' checked' : '');
		}

		$html_str = 	"$tab\t\t\t<div class='form-group' id='$div_id'>\n".
				"$tab\t\t\t\t<label for='$input_id' class='col-sm-3 control-label'>$label</label>\n".
				"$tab\t\t\t\t<div class='col-sm-8'>\n".
				"$tab\t\t\t\t\t<input type='$type' $class data-toggle='tooltip' name='$input_id' id='$input_id' title='$title' value='$value' $javascript $autocomplete $checked/>\n".
				"$tab\t\t\t\t</div>\n".
				"$tab\t\t\t</div>\n";
	
		return $html_str;
	}
/*
	function _display_sip_profiles ($ba, $sip_cfg)
	{
		$sip_profiles = explode('-', $sip_cfg['SipProfiles']);

		$html_str = '';
		ob_start();
?>
			<p class='text-center h4'><?php echo WIZARD_SIP_PROFILE_LIST_DIS; ?></p>
			<table class='table table-striped table-bordered'>
				<tr><th></th><th><?php echo SIP_NAME_DIS; ?></th><th><?php echo SIP_USER_DIS; ?></th><th><?php echo SIP_REGISTER_DIS; ?></th></tr>
<?php
		$html_str .= ob_get_clean();

		$i = 0;
		$query = $ba -> select('SELECT * FROM sip');
		while (($entry = $ba -> fetch_array($query)) && $i < 15) // Display for now only the 15th first SIP profiles
		{
			$html_str .= 	"\t\t\t\t\t<tr>\n"
					. "\t\t\t\t\t\t<td><input type='checkbox' name='". $this -> sip_profile ."[]' value='{$entry['id']}'". (in_array($entry['id'], $sip_profiles) ? ' checked' : '') ."></td>\n"
					. "\t\t\t\t\t\t<td>{$entry['name']}</td>\n"
					. "\t\t\t\t\t\t<td>{$entry['user']}</td>\n"
					. "\t\t\t\t\t\t<td>{$entry['register']}</td>\n"
					. "\t\t\t\t\t</tr>\n";
			$i++;
		}

		ob_start();
?>
			</table>
<?php
		$html_str .= ob_get_clean();

		return $html_str;
	}
*/
	function _display_parameters_value ($array_names, $array_parameters)
	{
		$html_str = '';
	
		foreach ($array_names as $id_para => $name_para)
		{
			if (isset($array_parameters[$id_para]) && strlen($array_parameters[$id_para]) > 0)
			{
				$html_str .= "\t\t\t\t$name_para = {$array_parameters[$id_para]} <br/>";
			}
		}

		return $html_str . "\n";
	}

	function _manual_content($sip_cfg)
	{
		$html_str = '';

		foreach ($this -> sip_array_parameter as $variable => $parameters)
		{
			$value = (isset($sip_cfg[$parameters['idurl']]) ? $sip_cfg[$parameters['idurl']] : '');
			$html_str .= $this -> _display_simple_field($variable."_div", $parameters['title'] , $variable, $parameters['tooltip'], $value, $parameters['input'], '', "\t");
		}

		return $html_str;
	}

	function _gateway_content($ba, $sip_cfg)
	{
/*
		$html_str = $this -> _display_sip_profiles($ba, $sip_cfg);

		ob_start();
?>
			<div class='text-center'>
				<input type='button' value='<?php echo WIZARD_CREATE_SIP_PROFILE_DIS; ?>' onclick="if ($('#sipProfile').is(':visible')) { $('#sipProfile').hide(); } else { $('#sipProfile').show(); }">
			</div>
			<div id='sipProfile' style='margin-top: 15px;'>
<?php 
		$html_str .= ob_get_clean();

		$html_str .= $this -> _sip_manual();

		ob_start();
?>
			</div>
<?php
	 	return $html_str . ob_get_clean();
*/
		return $this -> _manual_content($sip_cfg);
	}

	function _pbx_content()
	{
		$html_str = '';

		ob_start();
?>
			<div class="text-center">
				<p class='lead'><?php echo WIZARD_PBX_TITLE_DIS; ?></p>
			</div>
<?php
		$html_str .= ob_get_clean();

		foreach ($this -> pbx_array_parameter as $variable => $parameters)
		{ 
			$html_str .= $this -> _display_simple_field($variable."_div", $parameters['title'] , $variable, $parameters['tooltip'], '', $parameters['input'], '', "\t");
		}
		
		return $html_str;
	}

	function _provider_content()
	{
		$html_str = '';

		return $html_str;
	}

	// public
	function get_ids_array() 
	{
		return $this -> ids_array;
	}

	function get_content_modal ($ba, $sip_cfg) 
	{
		switch ($this -> which_scenario)
		{
			case 2:
				return $this -> _pbx_content();
			case 3:
				return $this -> _provider_content();
			case 4:
				return $this -> _manual_content($sip_cfg);
			default:
				return $this -> _gateway_content($ba, $sip_cfg);
		}
	}

	function get_javascript_code ()
	{
		ob_start();
?>	
<script type="text/javascript">
	$("#Sipform").validate({
		rules: {
			sip_name: {
				required: true,
			},
			sip_server: {
				required: true,
			},
		}
	});
</script>
<?php
		return ob_get_clean();
	}

	function organize_settings($ba, $sip_settings_input)
	{
/*
		if (isset($sip_settings['SipProfiles']))
		{
			$sip_profiles = $ba -> fetch_array($ba -> select("select * from sip where id='". str_replace("-", "", $sip_settings['SipProfiles']) ."'"));
			unset($sip_settings['SipProfiles']);

			// TODO : can be optimized using class variables
			if (isset($sip_profiles['name']) && (strlen($sip_profiles['name']) > 0))
			{
				$sip_settings['SipName'] = $sip_profiles['name'];
			}

			if (isset($sip_profiles['sip_proxy']) && (strlen($sip_profiles['sip_proxy']) > 0))
			{
				$sip_settings['SipServer'] = $sip_profiles['sip_proxy'];
			}
			else if (isset($sip_profiles['sip_registrar']) && (strlen($sip_profiles['sip_registrar']) > 0))
			{
				$sip_settings['SipServer'] = $sip_profiles['sip_registrar'];
			}
			else if (isset($sip_profiles['sip_domain']) && (strlen($sip_profiles['sip_domain']) > 0))
			{
				$sip_settings['SipServer'] = $sip_profiles['sip_domain'];
			}

			if (isset($sip_profiles['user']) && (strlen($sip_profiles['user']) > 0))
			{
				$sip_settings['SipUser'] = $sip_profiles['user'];
			}

			if (isset($sip_profiles['secret']) && (strlen($sip_profiles['secret']) > 0))
			{
				$sip_settings['SipSecret'] = $sip_profiles['secret'];
			}

			if (isset($sip_profiles['register']) && (strlen($sip_profiles['register']) > 0))
			{
				$sip_settings['SipRegister'] = $sip_profiles['register'];
			}
		}
*/
		foreach ($sip_settings_input as $parameter => $value)
		{
			$sip_settings[str_replace('SIP_', '', $parameter)] = $value;
		}

		return $sip_settings;
	}

	function get_summary_settings ($sip_settings)
	{
		$html_str = '';
		foreach ($sip_settings as $parameter => $value)
		{
			$html_str .= "$parameter = $value <br/>";
		}

		return $html_str;
	}
}
?>
